import java.util.*;
import org.omg.CORBA.*;
import javax.rmi.CORBA.Util;
import org.omg.PortableServer.*;

public class AdderServer {
  public static void main( String args[] ) throws Exception {
       Properties p = System.getProperties();
       p.put("org.omg.CORBA.ORBClass","com.sun.corba.se.internal.POA.POAORB");
       p.put("org.omg.CORBA.ORBSingletonClass","com.sun.corba.se.internal.corba.ORBSingleton");
       ORB orb = ORB.init(args,p);
       POA rootPOA = (POA)orb.resolve_initial_references("RootPOA");
       Policy[] tpolicy = new Policy[3];
       tpolicy[0] = rootPOA.create_lifespan_policy(LifespanPolicyValue.TRANSIENT);
       tpolicy[1] = rootPOA.create_request_processing_policy(RequestProcessingPolicyValue.USE_ACTIVE_OBJECT_MAP_ONLY);
       tpolicy[2] = rootPOA.create_servant_retention_policy(ServantRetentionPolicyValue.RETAIN);
       POA tPOA = rootPOA.create_POA("MyTransientPOA",null,tpolicy);
       tPOA.the_POAManager().activate();
	
       Adder adder = new RemoteAdder();
       _RemoteAdder_Tie tie = (_RemoteAdder_Tie)Util.getTie(adder);
       byte[] id = "Adder".getBytes();
       tPOA.activate_object_with_id(id,tie);
       javax.naming.Context ctx = new javax.naming.InitialContext();
       ctx.rebind("Adder", tPOA.create_reference_with_id(id,tie._all_interfaces(tPOA,id)[0]));
       ctx.close();
       System.out.println("Adder is bound");
       orb.run();
  }
}
