import java.net.*;
import java.io.*;

public class Adder extends Thread {

  static int num = 0;

  Socket s;
  ObjectInputStream in;
  ObjectOutputStream out;

  public Adder( Socket s ) throws IOException {
    this.s = s;
    in = new ObjectInputStream(s.getInputStream());
    out = new ObjectOutputStream(s.getOutputStream());
  }

  public void run() {
    boolean running = true;
    try {
      while( running ){
        String command = in.readUTF();
        if( "add".equals(command) ){
            int n = in.readInt();
            num += n;
        } else if( "get".equals(command) ){
            out.writeInt(num);
            out.flush();
        } else {
            running = false;
        }
      }
    } catch ( IOException e ){
      e.printStackTrace();
    } finally {
      try {
          s.close();
      } catch ( IOException e ){ e.printStackTrace(); }
    }
  }

  public static void main( String[] args ) throws IOException {
     ServerSocket ss = new ServerSocket(1234);
     while( true ){
        try {
           Socket s = ss.accept();
           new Adder(s).start();
        } catch ( IOException e ){ e.printStackTrace(); }
     }  
  }

}