package engine;

import java.rmi.*;
import java.rmi.server.*;
import compute.*;

public class ComputeEngine extends UnicastRemoteObject
                           implements Compute
{
    public ComputeEngine() throws RemoteException {
        super();
    }

    public java.io.Serializable executeTask(Task t) {
        return t.execute();
    }

    public static void main(String[] args) throws Exception {
        System.setSecurityManager(new RMISecurityManager());
	if (args.length > 0) java.rmi.registry.LocateRegistry.createRegistry(1099);
        Compute engine = new ComputeEngine();
        Naming.rebind("Compute", engine);
        System.out.println("ComputeEngine bound.");
        System.out.println("Press <Enter> to terminate.");
	System.in.read();
        Naming.unbind("Compute");
        System.out.println("ComputeEngine unbound.");
	
    }
}
