import java.awt.*;
import java.rmi.*;
import java.rmi.server.*;

    public class CallMeBackImpl extends UnicastRemoteObject implements CallMeBack {

        Label label;
        int calledBack = 0;
        Caller server;

        public void callMeBack(){  calledBack ++; label.setText(""+calledBack); }

        public CallMeBackImpl( Label label, String serverName ) throws RemoteException {
           this.label = label;
           try {
              server = (Caller)Naming.lookup("rmi://"+serverName);
           } catch (Exception e){
              label.setText(e.toString()); 
              e.printStackTrace(); 
           }
        }

        public void start(){
          try{
             server.register(this);       
          } catch ( RemoteException e ){
             label.setText(e.toString()); 
             e.printStackTrace(); 
          }
        }

        public void stop(){
          try{
             server.deregister(this);       
          } catch ( RemoteException e ){
             label.setText(e.toString()); 
             e.printStackTrace(); 
          }
        }

    }